'''
PWM output on Raspberry Pi GPIO
https://www.electronicwings.com/raspberry-pi/
raspberry-pi-pwm-generation-using-python-and-c
'''

import RPi.GPIO as GPIO
from time import sleep

ledpin = 12                       # PWM0
GPIO.setwarnings(False)           # disable warnings
GPIO.setmode(GPIO.BOARD)          # set pin numbering system
GPIO.setup(ledpin,GPIO.OUT)       # set pin as output
pi_pwm = GPIO.PWM(ledpin,1000)    # create PWM instance with specified frequency
pi_pwm.start(0)                   # start PWM with specified duty cycle

while True:
    for duty in range(0,101,1):        # count duty cycle up from 0 to 100
        pi_pwm.ChangeDutyCycle(duty)
        sleep(0.05)
    sleep(0.1)

    for duty in range(100,-1,-1):      # count duty cycle down from 100 to 0
        pi_pwm.ChangeDutyCycle(duty)
        sleep(0.05)
    sleep(0.1)
